const Applet = imports.ui.applet;
const Gio = imports.gi.Gio;
const Lang = imports.lang;
const Mainloop = imports.mainloop;
const Clutter = imports.gi.Clutter;
const St = imports.gi.St;
const Util = imports.misc.util;
const PopupMenu = imports.ui.popupMenu;
const UPowerGlib = imports.gi.UPowerGlib;
const Settings = imports.ui.settings;
const AppletDir = imports.ui.appletManager.applets['calendar@cdos.org'];
const Calendar = AppletDir.calendar;
const CinnamonDesktop = imports.gi.CinnamonDesktop;
const Cairo = imports.cairo; //wj

String.prototype.capitalize = function() {
    return this.charAt(0).toUpperCase() + this.slice(1);
}
/* add by liting @2015-11-11, new menuItem which contains a clock
 * Draw circle, ticks, and arms, repaint it every second by Mainloop's timeout
 * Pay attention to polar coordinate if you want to have a try.
 */
function MyPopupMenuItem()
{
    this._init.apply(this, arguments);
}

MyPopupMenuItem.prototype =
{
    __proto__: PopupMenu.PopupBaseMenuItem.prototype,
    _init: function(button1, button2, button3, params)
    {
        PopupMenu.PopupBaseMenuItem.prototype._init.call(this, params);
//	this.box = new St.BoxLayout();
        this.canvasBox = new St.DrawingArea({reactive: true});
	this.canvasBox.set_size(140,140);
	this.canvasBox.connect('repaint', Lang.bind(this, this._drawClock));
	this.addActor(this.canvasBox,  { span: -1, expand: true });
//        this.box.add(this.canvasBox);
//	this.addActor(this.box);
//	this.canvasBox.queue_repaint();
//	this._drawClock();
//	this.setTimer();
    },

    stopRepaint: function() {
	global.log("stop repaint");
	Mainloop.source_remove(this.timeoutId);
    },
    _callRepaint: function() {
// FIXME: SHOULD REMOVE SOURCE FROM MAINLOOP IF MENU HAS BEEN CLOSED.
	global.log("repaint clock");
	this.timeoutId = Mainloop.timeout_add_seconds(1, Lang.bind(this, this._callRepaint));
	this.canvasBox.queue_repaint();
    },

    _drawOuterCircle: function(clockX, clockY, clockRadius, context){
	context.save();
	//context.setSourceRGBA(100, 140, 230, 0.7);
        context.arc(clockX,clockY, clockRadius, 0,Math.PI*2);            
        context.stroke(); 
        context.restore();  

    },

    _drawCircle: function(clockX, clockY, clockRadius, context){
	context.save();
	//context.setSourceRGBA(100, 140, 230, 0.9);
        context.arc(clockX,clockY, clockRadius, 0,Math.PI*2);            
        context.stroke(); 
        context.arc(clockX,clockY, clockRadius-1, 0,Math.PI*2);            
	context.stroke();
        context.restore();  

    },

    _drawTicks: function(clockX, clockY, clockRadius, context){            
        
        for(var angle = 0,cnt = 0; angle < Math.PI*2; angle = angle + Math.PI/30, cnt++){                
     		this._drawTick(angle, clockX, clockY, clockRadius,cnt, context);               
    	}
    },

    _drawTick: function (angle,clockX, clockY, clockRadius,cnt, context){                
	let tickWidth = 0;
        context.save();                                
	context.setLineWidth(1);
        if(cnt%5 === 0){                       
                tickWidth = 5;                    
                //context.setSourceRGBA(100,140,230,0.9);                
        }else{                    
		clockRaduis = clockRadius-1;
                tickWidth = 2;                    
                //context.setSourceRGBA(100,140,230,0.7);                
        }
        context.moveTo(clockX+Math.cos(angle)*(clockRadius-tickWidth), clockY +Math.sin(angle)*(clockRadius-tickWidth));                
        context.lineTo(clockX+Math.cos(angle)*(clockRadius), clockY +Math.sin(angle)*(clockRadius));                
        context.stroke();                                
        context.restore();            
    }, 

    _drawText: function(clockX, clockY, clockRadius, context){
	context.save();            
        context.textAlign = "center";            
        context.textBaseline = "middle";            
        context.setFontSize(8);            
        //context.setSourceRGBA(100, 150, 230, 0.9);            
	let i = 0;
        for(var angle=0; angle<Math.PI*2; angle= angle+Math.PI/6 ){
	    context.moveTo(clockX+Math.cos(angle-Math.PI/2)*(clockRadius-10)-2, clockY+Math.sin(angle-Math.PI/2)*(clockRadius-10)-2); 
	    if(angle == 0){
	    	context.showText("12");
	    }else{
		context.showText(i+"");
	    }  
	    i++;
        }
        context.restore();

    },
  
    _drawArm: function(clockX, clockY, clockRadius, progress, context, armThickness,armLength, armColor) {
	var armRadians = (2 * Math.PI * progress) - (Math.PI/2);
        var targetX = clockX + Math.cos(armRadians) * (armLength * clockRadius);
        var targetY = clockY + Math.sin(armRadians) * (armLength * clockRadius);
	context.save(); 
        context.setLineWidth(armThickness);
	if(armColor == "second"){
        	//context.setSourceRGB(50,60,40);
		var secLeftArm= (0.5+progress)*2*Math.PI -(Math.PI/2); //\short part of second's hand
		var targetx2 = clockX + Math.cos(secLeftArm)*(0.2 * clockRadius);
		var targety2 = clockY + Math.sin(secLeftArm)*(0.2 * clockRadius);
		context.moveTo(clockX,clockY);
		context.lineTo(targetx2, targety2);
		context.stroke();
		
	        context.moveTo(clockX, clockY); // Start at the center
        	context.lineTo(targetX, targetY); // long part of second
	        context.stroke();
		context.restore();

	}else{ // for hour and minute's hand
		//context.setSourceRGBA(51,51,51,1);
        	context.moveTo(clockX, clockY); // Start at the center
        	context.lineTo(targetX, targetY); // Draw a line outwards
       		context.stroke();
		context.restore();
	}
    },

    _drawClock: function(area){
	let now = new Date();
        let h = now.getHours();
        let m = now.getMinutes();
        let s = now.getSeconds();

	let [width, height] = area.get_surface_size();
	let context = area.get_context();
	let clockX = width / 2;
        let clockY = height / 2;
	let clockRadius = clockX-2;
	//this._drawOuterCircle(clockX, clockY, clockRadius, context);
	//this._drawOuterCircle(clockX, clockY, clockRadius-4, context);
	//this._drawCircle(clockX, clockY, clockRadius-4, context);
//	this._drawText(clockX, clockY, clockRadius, context);
	//this._drawTicks(clockX, clockY, clockRadius-6, context);
	this._drawArm(clockX, clockY, clockRadius, h/12+m/720, context, 3, 0.7, "hour");
	this._drawArm(clockX, clockY, clockRadius, m/60, context, 2, 0.8, "minute");
	this._drawArm(clockX, clockY, clockRadius, s/60, context, 1.5, 0.85, "second");

    },
    _onButtonReleaseEvent: function (actor, event){

    }
}; 

function _onVertSepRepaint (area)
{
    let cr = area.get_context();
    let themeNode = area.get_theme_node();
    let [width, height] = area.get_surface_size();
    let stippleColor = themeNode.get_color('-stipple-color');
    let stippleWidth = themeNode.get_length('-stipple-width');
    let x = Math.floor(width/2) + 0.5;
    cr.moveTo(x, 0);
    cr.lineTo(x, height);
    Clutter.cairo_set_source_color(cr, stippleColor);
    cr.setDash([1, 3], 1); // Hard-code for now
    cr.setLineWidth(stippleWidth);
    cr.stroke();
};

/*
 * wuj
 * Separator 
*/

function Separator(params) {
    this._init(params);
}
Separator.prototype = {
    __proto__: PopupMenu.PopupBaseMenuItem.prototype,

    _init: function(params) {
        PopupMenu.PopupBaseMenuItem.prototype._init.call(this, {
            reactive: false
        });
        let style_class = params && params['style_class'] ? params.style_class :  'menu-separator-line';
        this.actor.style = 'padding: 0;';
        this._drawingArea = new St.DrawingArea({
            style_class: style_class
        });
        this.addActor(this._drawingArea, {
            span: -1,
            expand: true
        });
        this._drawingArea.connect('repaint', Lang.bind(this, this._onRepaint));
    },

    _onRepaint: function(area) {
        let cr = area.get_context();
        let themeNode = area.get_theme_node();
        let [width, height] = area.get_surface_size();
        let margin = themeNode.get_length('-margin-horizontal');
        let gradientHeight = themeNode.get_length('-gradient-height');
        let startColor = themeNode.get_color('-gradient-start');
        let endColor = themeNode.get_color('-gradient-end');

        let gradientWidth = (width - margin * 2);
        let gradientOffset = (height - gradientHeight) / 2;
        let pattern = new Cairo.LinearGradient(margin, gradientOffset, width - margin, gradientOffset + gradientHeight);
        pattern.addColorStopRGBA(0, startColor.red / 255, startColor.green / 255, startColor.blue / 255, startColor.alpha / 255);
        pattern.addColorStopRGBA(0.5, endColor.red / 255, endColor.green / 255, endColor.blue / 255, endColor.alpha / 255);
        pattern.addColorStopRGBA(1, startColor.red / 255, startColor.green / 255, startColor.blue / 255, startColor.alpha / 255);
        cr.setSource(pattern);
        cr.rectangle(margin, gradientOffset, gradientWidth, gradientHeight);
        cr.fill();
    }
}

function MyApplet(orientation, panel_height, instance_id) {
    this._init(orientation, panel_height, instance_id);
}

MyApplet.prototype = {
    __proto__: Applet.TextApplet.prototype,

    _init: function(orientation, panel_height, instance_id) {        
        Applet.TextApplet.prototype._init.call(this, orientation, panel_height, instance_id);
        this.actor.add_style_class_name('applet-calendar-bg');
        try {    

            this.clock = new CinnamonDesktop.WallClock();

            this.settings = new Settings.AppletSettings(this, "calendar@cdos.org", this.instance_id);

            this.menuManager = new PopupMenu.PopupMenuManager(this);
            
            this._orientation = orientation;
            
            this._initContextMenu();
                                     
            this._calendarArea = new St.BoxLayout({name: 'calendarArea' });
            this.menu.addActor(this._calendarArea);

            // Fill up the first column

            let vbox = new St.BoxLayout({vertical: true});
            this._calendarArea.add(vbox);
	                // Date
            //this._date = new St.Label();
	    //this._labelBin = new St.Bin();
	    //this._labelBin.child = this._date;
            //this._date.style_class = 'datemenu-date-label';
            //vbox.add(this._labelBin);
            //wj
            this._date = new St.Button({
                label: '',
                style_class: 'datemenu-date-label'
            });
            this._date.reactive = true;
            vbox.add(this._date);

            this._eventSource = null;
            this._eventList = null;

            // Calendar
	    this._hbox = new St.BoxLayout({vertical: false});// liting
            this._calendar = new Calendar.Calendar(this._eventSource, this.settings);       
	    vbox.add(this._hbox);
            this._hbox.add(this._calendar.actor);
//liting
	    this._clock = new MyPopupMenuItem();
            this._clock.actor.add_style_class_name('calendar-clock');//wj
	    this._timeLabel = new St.Label();
	    this._timeLabel.style_class = 'datemenu-date-label';
	    let vdialbox = new St.BoxLayout({vertical: true});
	    let emptyLine = new PopupMenu.PopupSeparatorMenuItem();
	    vdialbox.add(this._clock.actor);
	    //vdialbox.add(emptyLine.actor);
	    vdialbox.add(this._timeLabel);
	    this._hbox.add(vdialbox);

            //wj
            //let item = new PopupMenu.PopupMenuItem(_("Date and Time Settings"))
            //item.connect("activate", Lang.bind(this, this._onLaunchSettings));
            let button = new St.Button({
                label: _("Date and Time Settings"),
                style_class: 'calendar-time-setting-button'
            });
            button.connect("clicked", Lang.bind(this, this._onLaunchSettings));
            //this.menu.addMenuItem(item);
            if (button) {
                //let separator = new PopupMenu.PopupSeparatorMenuItem();
                //separator.setColumnWidths(1);
                let separator = new Separator({style_class:'calendar-h-separator'});
                vbox.add(separator.actor, {y_align: St.Align.END, expand: true, y_fill: false});

                //item.actor.can_focus = false;
                button.reactive = true;
                //global.reparentActor(item.actor, vbox);
                global.reparentActor(button, vbox);
            }

            // Track changes to clock settings
            //this._dateFormatFull = _("%Y/%m/%d %A");
            //this._dateFormatFull = _("    %Y/%m/%d");
            this._dateFormatFull = _("%Y/%m/%d");
            this._timeFormatFull = _("    %H:%M:%S  %n      %A");

            this.settings.bindProperty(Settings.BindingDirection.IN, "use-custom-format", "use_custom_format", this.on_settings_changed, null);
            this.settings.bindProperty(Settings.BindingDirection.IN, "custom-format", "custom_format", this.on_settings_changed, null);        

            // https://bugzilla.gnome.org/show_bug.cgi?id=655129
            this._upClient = new UPowerGlib.Client();
            this._upClient.connect('notify-resume', this._updateClockAndDate);

            // Start the clock
            this.on_settings_changed();
            this._updateClockAndDatePeriodic();
     
        }
        catch (e) {
            global.logError(e);
        }
    },
    
    on_applet_clicked: function(event) {
	if(this.menu.isOpen)
		this._clock.stopRepaint();
	else
		this._clock._callRepaint();
        this.menu.toggle();
    },

    on_settings_changed: function() {        
        this._updateClockAndDate();
    },

    on_custom_format_button_pressed: function() {
        Util.spawnCommandLine("xdg-open http://www.foragoodstrftime.com/");
    },
    
    _onLaunchSettings: function() {
        this.menu.close();
        Util.spawnCommandLine("cdos-settings calendar");
    },

    _updateClockAndDate: function() {
        let now = new Date();        
	this.custom_format = "   %H:%M:%S  %n %Y/%m/%d"
	if(this.custom_format){
            let label_string = now.toLocaleFormat(this.custom_format);
            if (!label_string) {
                global.logError("Calendar applet: bad time format string - check your string.");
                label_string = "~CLOCK FORMAT ERROR~ " + now.toLocaleFormat("%l:%M %p");
                //label_string = "~CLOCK FORMAT ERROR~ " + now.toLocaleFormat("%H:%M:%S  %n %Y/%m/%d");
            }
	    this.set_applet_label(label_string);   

	}
	else{
	    if (this.clock) { // We lose cdos-desktop temporarily during suspend
                this.set_applet_label(this.clock.get_clock().capitalize());
	    }
	}

        // Applet label
        // if (this.use_custom_format) {
	//     global.log("===app:2:"+this.custom_format);
        //     let label_string = now.toLocaleFormat(this.custom_format);
        //     if (!label_string) {
        //         global.logError("Calendar applet: bad time format string - check your string.");
        //         label_string = "~CLOCK FORMAT ERROR~ " + now.toLocaleFormat("%l:%M %p");
        //         //label_string = "~CLOCK FORMAT ERROR~ " + now.toLocaleFormat("%H:%M:%S  %n %Y/%m/%d");
        //     }
        //     global.log("=====app:3:"+label_string);
        //     this.set_applet_label(label_string);   
        // }
        // else {
        //     if (this.clock) { // We lose cdos-desktop temporarily during suspend
        //         this.set_applet_label(this.clock.get_clock().capitalize());
        //     }
        // }

        // Applet content
        let dateFormattedFull = now.toLocaleFormat(this._dateFormatFull).capitalize();
        let timeFormattedFull = now.toLocaleFormat(this._timeFormatFull).capitalize();
        if (dateFormattedFull !== this._lastDateFormattedFull) {
            //this._date.set_text(dateFormattedFull);
            //wj
            this._date.label = dateFormattedFull;
            this.set_applet_tooltip(dateFormattedFull);
            this._lastDateFormattedFull = dateFormattedFull;
        }
        this._timeLabel.set_text(timeFormattedFull);
    },

    _updateClockAndDatePeriodic: function() {
        this._updateClockAndDate();
        this._periodicTimeoutId = Mainloop.timeout_add_seconds(1, Lang.bind(this, this._updateClockAndDatePeriodic));
    },
    
    on_applet_removed_from_panel: function() {
        if (this._periodicTimeoutId){
            Mainloop.source_remove(this._periodicTimeoutId);
        }
    },

    _initContextMenu: function () {
        if (this._calendarArea) this._calendarArea.unparent();
        if (this.menu) this.menuManager.removeMenu(this.menu);
        
        this.menu = new Applet.AppletPopupMenu(this, this._orientation);
        this.menuManager.addMenu(this.menu);
        
        if (this._calendarArea){
            this.menu.addActor(this._calendarArea);
            this._calendarArea.show_all();
        }
        
        // Whenever the menu is opened, select today
        this.menu.connect('open-state-changed', Lang.bind(this, function(menu, isOpen) {
            if (isOpen) {
                let now = new Date();
                /* Passing true to setDate() forces events to be reloaded. We
                 * want this behavior, because
                 *
                 *   o It will cause activation of the calendar server which is
                 *     useful if it has crashed
                 *
                 *   o It will cause the calendar server to reload events which
                 *     is useful if dynamic updates are not supported or not
                 *     properly working
                 *
                 * Since this only happens when the menu is opened, the cost
                 * isn't very big.
                 */
                //this._calendar.setDate(now, true);
                this._calendar.reset(); //wj
                // No need to update this._eventList as ::selected-date-changed
                // signal will fire
            }
        }));
    },
    
    on_orientation_changed: function (orientation) {
        this._orientation = orientation;
        this._initContextMenu();
    }
    
};

function main(metadata, orientation, panel_height, instance_id) {  
    let myApplet = new MyApplet(orientation, panel_height, instance_id);
    return myApplet;      
}
