/*
 * add by liting @2015-0-27
 * icons Group
 */
const DocInfo = imports.misc.docInfo;
const Gtk = imports.gi.Gtk;
const Gio = imports.gi.Gio;
const St = imports.gi.St;
//const PopupMenu = imports.ui.xunliPopupMenu;
const PopupMenu = imports.ui.popupMenu;
const Lang = imports.lang;
const Applet = imports.ui.applet;
const AppletManager= imports.ui.appletManager;
const Signals = imports.signals;

function AppletButton(appletMenuItem, icon) {
    this._init(appletMenuItem, icon);
}

AppletButton.prototype = {
    _init: function(appletMenuItem, icon) {
        this.actor = new St.Button({ reactive: true, style_class: 'menu-favorites-button' });
        let iconObj = new St.Icon({icon_name: icon, icon_type: St.IconType.SYMBOLIC, icon_size: 22});
        this.actor.set_child(iconObj);
        iconObj.realize()
    }
};

function MyPopupMenuManager(){
    this._init.apply(this, arguments);
}

MyPopupMenuManager.prototype = 
{
    __proto__:PopupMenu.PopupMenuManager.prototype,
    _init: function(owner) {
        this._owner = owner;
        this.grabbed = false;

        this._eventCaptureId = 0;
        this._enterEventId = 0;
        this._leaveEventId = 0;
        this._keyFocusNotifyId = 0;
        this._activeMenu = null;
        this._menus = [];
        this._menuStack = [];
        this._preGrabInputMode = null;
        this._grabbedFromKeynav = false;
    },

    //    this._keyFocusNotifyId = global.stage.connect('notify::key-focus', Lang.bind(this, this._onKeyFocusChanged));
    /*
     * In Grouped-icons, if key foucus out, popupmenu will be closed
     * redefined this function to avoid this. :) happy
     */
     _onKeyFocusChanged: function() {
        return;
    }

};

function MyPopupMenuItem()
{
    this._init.apply(this, arguments);
}

MyPopupMenuItem.prototype =
{
    __proto__: PopupMenu.PopupBaseMenuItem.prototype,
    _init: function(button1, button2, button3, params)
    {
        PopupMenu.PopupBaseMenuItem.prototype._init.call(this, params);
        this.box = new St.BoxLayout({ name: 'groupItem', vertical: false, style: 'spacing: 5px;' });
    	this.box.set_style("height:32px;");
    	this.actor.remove_style_class_name("popup-menu-item");
    	this.box.connect('button-press-event', Lang.bind(this, this._onButtonPressEvent));
        //this.box.add(button1.actor);
        //this.box.add(button2.actor);
        //this.box.add(button3.actor);
    	this.box.add(button1);
        this.addActor(this.box);
	
    },
    add_less_three: function(actor){
		this.box.add(actor);
    },
    _onButtonPressEvent: function (actor, event){
        let [x, y] = event.get_coords();
        let target = global.stage.get_actor_at_pos(Clutter.PickMode.ALL, x, y);
        global.log("item active "+ target)
        if(event.get_button() === 1){
                global.log(target.get_parent());
        }
        return true;
    },
    _onHoverChanged:function(){
		return false;			
	},
    _onButtonReleaseEvent: function (actor, event){
		global.log("conflicked??????");

    },
    activate: function(event){
        let [x, y] = event.get_coords();
        let target = global.stage.get_actor_at_pos(Clutter.PickMode.ALL, x, y);
        global.log("item active "+ target)
        if(event.get_button() === 1){
            global.log(target.get_parent());
        }
        //	let parent = this.actor.get_parent();
        //	global.log(parent);
    }
}; 

/* modifide by lyl */
function MyApplet(metadata, orientation, panel_height) {
    this._init(metadata, orientation, panel_height);
}

MyApplet.prototype = {
    __proto__: Applet.IconApplet.prototype,

    _init: function(metadata, orientation, panel_height) { // modified by lyl
        Applet.IconApplet.prototype._init.call(this, orientation, panel_height);
        
        try {        
            Gtk.IconTheme.get_default().append_search_path(metadata.path); //add by lyl
            this.set_applet_icon_symbolic_name("xunli"); // modified by lyl
            this.set_applet_tooltip(_("running applets"));
    	    this._orientation = orientation;        
            this.menuManager = new MyPopupMenuManager(this);
            
            //this.menu = new PopupMenu.AppletPopupMenu(this, orientation);
            this.menu = new Applet.AppletPopupMenu(this, orientation);
            this.menu.addCommandlineAction(_("Settings"),"cellrendercombo");

            this.menuManager.addMenu(this.menu);
            
            this.xunlimenuItem= null;           
            this.seperator = null;
            this.index = 0;  
            //this._display();
        }catch (e) {
            global.logError(e);
        }
    },
    
    on_applet_clicked: function(event) {
        this.menu.toggle();        
    },

    _onButtonPressEvent: function(actor, event){
      if (event.get_button() == 1) {
            if (!this._draggable.inhibit) {
                return false;
            } else {
                if (this._applet_context_menu.isOpen) {
                    this._applet_context_menu.toggle();
                }
                this.on_applet_clicked(event);
            }
        }
//        if (event.get_button()==3){
//            if (this._applet_context_menu._getMenuItems().length > 0) {
//                this._applet_context_menu.toggle();
//            }
//        }
        return true;

    },

    add_seperator: function(){
        global.log("add seperator in xunli");
        //	let seperator = new PopupMenu.PopupSeparatorMenuItem();
        //	this.menu.addMenuItem(separator);
        //	let newItem = new MyPopupMenuItem(seperator.actor, null, null, {});
        //        this.menu.addMenuItem(newItem);	
        //this.menu.xunliAppletsAction();
        this.menu.addCommandlineAction(_("Settings"),"cellrendercombo");
    },
    reload_menu: function(){
    	this.menuManager.removeMenu(this.menu);
    	this.menu = new Applet.AppletPopupMenu(this, this._orientation);
        this.menu.addCommandlineAction(_("Settings"),"cellrendercombo");
        this.menuManager.addMenu(this.menu);
    	this.xunlimenuItem= null;
        this.seperator = null;
    	this.index = 0;
    },
    add_other_applet: function(actor){
        if(this.index % 3 === 0){
            this.xunlimenuItem = new MyPopupMenuItem(actor, {});
            this.menu.addMenuItem(this.xunlimenuItem,0);
                
        }else{
            this.xunlimenuItem.add_less_three(actor);
        }
        this.index++;
    }
};

function main(metadata, orientation, panel_height) {  
    let myApplet = new MyApplet(metadata, orientation, panel_height); //modified by lyl
    return myApplet;      
}
