const Applet = imports.ui.applet;
const Lang = imports.lang;
const Main = imports.ui.main;
const Gtk = imports.gi.Gtk;
const Settings = imports.ui.settings;

function MyApplet(metadata, orientation, panel_height, instance_id) {
    this._init(metadata, orientation, panel_height, instance_id);
}

MyApplet.prototype = {
    __proto__: Applet.IconApplet.prototype,

    _init: function(metadata, orientation, panel_height, instance_id) {
        Applet.IconApplet.prototype._init.call(this, orientation, panel_height, instance_id);

        try {            
            Gtk.IconTheme.get_default().append_search_path(metadata.path);
				this.actor.remove_style_class_name("applet-box");
				this._applet_icon_box.set_margin_left(8);
            this.set_applet_icon_name("Scale");
            this.set_applet_tooltip(_("Scale"));            
            this._hover_activates = false;            

            this.settings = new Settings.AppletSettings(this, metadata["uuid"], this.instance_id);

            this.settings.bindProperty(Settings.BindingDirection.IN,
                                       "activate-on-hover",
                                       "_hover_activates",
                                       function () {});


//            this.actor.connect('enter-event', Lang.bind(this, this._onEntered));
	    this.actor.connect('key-focus-in', Lang.bind(this, this._onKeyFocusIn));
            this.actor.connect('key-focus-out', Lang.bind(this, this._onKeyFocusOut));
	    this.actor.connect('notify::hover', Lang.bind(this, this._onHoverChanged));
	    Main.overview.connect('overview-background-button-release', Lang.bind(this, this._onOverviewBackground)); // add by liting
        }
        catch (e) {
            global.logError(e);
        }
    },
// add by liting
    _onKeyFocusIn: function (actor) {
        this.setHoverChanged(true);
    },

    _onKeyFocusOut: function (actor) {
        this.setHoverChanged(false);
    },

    _onHoverChanged: function(actor){
	this.setHoverChanged(actor.hover);
    },
    setHoverChanged: function(active) {
//	this.set_applet_icon_name("Scale-hover");
	let activeChanged = active != this._hover_activates;
	if(activeChanged){
		this._hover_activates = active;
		if(this._hover_activates){
			this.set_applet_icon_name("Scale-hover");
			this.actor.grab_key_focus();
		}else{
			this.set_applet_icon_name("Scale");
		}
	}
    },
// end
    on_applet_clicked: function(event) {
//        if (this._hover_activates)
//            return;
        this.doAction();
    },

    _onEntered: function(event) {
        if (!this._hover_activates || global.settings.get_boolean("panel-edit-mode"))
            return;
        this.doAction();
    },

    doAction: function() {
        if (!Main.overview.animationInProgress)
            Main.overview.toggle();
    },
// add by liting @2015-11-03, hide overview when single clicked
    _onOverviewBackground: function() {
//	global.log("in in in in in in in scale");
	Main.overview.hide();
    }
// end
};

function main(metadata, orientation, panel_height, instance_id) {
    let myApplet = new MyApplet(metadata, orientation, panel_height, instance_id);
    return myApplet;
}
